package stackjava.com.tutorial;

import java.util.concurrent.*;

public class Demo5 {
	public static void main(String[] args) throws InterruptedException, ExecutionException {
		ExecutorService executor = Executors.newFixedThreadPool(10);

		CompletableFuture<Integer> future1 = CompletableFuture.supplyAsync(() -> Calculator.add(1,2), executor);
		CompletableFuture<Integer> future2 = CompletableFuture.supplyAsync(() -> Calculator.add(1,3), executor);
		CompletableFuture<Integer> future3 = CompletableFuture.supplyAsync(() -> Calculator.add(2,3), executor);

		CompletableFuture<Void> futureAll = CompletableFuture.allOf(future1, future2, future3);
		futureAll.thenRunAsync(()->{
			System.out.println("All future is Done!");
		});

		System.out.println("Done");
		executor.shutdown();
	}
}
